#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;
using System.Windows.Forms.Integration;


using WPFUI;
#endregion usings

namespace VVVV.Nodes
{
    #region PluginInfo
    [PluginInfo(Name = "VVVVPF", Category = "UI", Help = "Basic template example", Tags = "c#", AutoEvaluate =true)]
    #endregion PluginInfo
    public class UIVVVVPFNode : System.Windows.Forms.UserControl, IPluginEvaluate, IUserInputWindow
    {
        [Input("Slider1")]
        public IDiffSpread<int> Slider1In;

        [Input("Slider2")]
        public IDiffSpread<int> Slider2In;

        [Input("Text")]
        public IDiffSpread<string> Text1In;

        [Input("Toggle")]
        public IDiffSpread<bool> ToggleIn;

        [Input("ProgressBar")]
        public IDiffSpread<int> ProgressBarIn;

        [Output("Slider1")]
        public ISpread<int> Slider1Out;

        [Output("Slider2")]
        public ISpread<int> Slider2Out;

        [Output("Text")]
        public ISpread<string> Text1Out;

        [Output("Button1")]
        public ISpread<bool> Button1Out;

        [Output("Toggle")]
        public ISpread<bool> ToggleOut;

        private readonly ElementHost _container = new ElementHost { Dock = System.Windows.Forms.DockStyle.Fill };

        SimpleUserControl suc = new SimpleUserControl();
        SimpleUserControlViewModel sucVM = new SimpleUserControlViewModel();

        public IntPtr InputWindowHandle
        { 
            get { return _container.Handle; }
        }

        public UIVVVVPFNode()
        {
            Controls.Clear();
            _container.Child = suc;
            Controls.Add(_container);

            sucVM = suc.DataContext as SimpleUserControlViewModel;
        }

        public void Evaluate(int SpreadMax)
        {

            if(Slider1In.SliceCount > 0)
            {
                if (Slider1In.IsChanged)
                {
                    sucVM.Slider1 = Slider1In[0];
                }
            }

            if (Slider2In.SliceCount > 0)
            {
                if (Slider2In.IsChanged)
                {
                    sucVM.Slider2 = Slider2In[0];
                }
            }

            if (Text1In.SliceCount > 0)
            {
                if (Text1In.IsChanged)
                {
                    sucVM.TextBox1 = Text1In[0];
                }
            }

            if (ToggleIn.SliceCount > 0)
            {
                if (ToggleIn.IsChanged)
                {
                    sucVM.ToggleButton1 = ToggleIn[0];
                }
            }

            if (ProgressBarIn.SliceCount > 0)
            {
                if (ProgressBarIn.IsChanged)
                {
                    sucVM.ProgressBar = ProgressBarIn[0];
                }
            }

            Button1Out.SliceCount = 1;
            Button1Out[0] = sucVM.Button1;

            Slider1Out.SliceCount = 1;
            Slider1Out[0] = sucVM.Slider1;

            Slider2Out.SliceCount = 1;
            Slider2Out[0] = sucVM.Slider2;

            Text1Out.SliceCount = 1;
            Text1Out[0] = sucVM.TextBox1;

            ToggleOut.SliceCount = 1;
            ToggleOut[0] = sucVM.ToggleButton1;
        }
    }
}
