﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;

namespace WPFUI
{
    public class SimpleUserControlViewModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        protected void NotifyPropertyChanged(String propertyname)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyname));
            }
        }

        private int _slider1;
        public int Slider1
        {
            get
            {
                return _slider1;
            }
            set
            {
                _slider1 = value;
                NotifyPropertyChanged("Slider1");
            }
        }

        private int _slider2;
        public int Slider2
        {
            get
            {
                return _slider2;
            }
            set
            {
                _slider2 = value;
                NotifyPropertyChanged("Slider2");
            }
        }

        private string _textbox1;
        public string TextBox1
        {
            get
            {
                return _textbox1;
            }
            set
            {
                _textbox1 = value;
                NotifyPropertyChanged("TextBox1");
            }
        }

        private bool _button1;
        public bool Button1
        {
            get
            {
                return _button1;
            }
            set
            {
                _button1 = value;
                NotifyPropertyChanged("Button1");
            }
        }

        private bool _togglebutton1;
        public bool ToggleButton1
        {
            get
            {
                return _togglebutton1;
            }
            set
            {
                _togglebutton1 = value;
                NotifyPropertyChanged("ToggleButton1");
            }
        }

        private int _progressbar;
        public int ProgressBar
        {
            get
            {
                return _progressbar;
            }
            set
            {
                _progressbar = value;
                NotifyPropertyChanged("ProgressBar");
            }
        }

        private bool _canExecute;

        private ICommand _clickCommand;
        public ICommand ClickCommand
        {
            get
            {
                return _clickCommand ?? (_clickCommand = new CommandHandler(() => ButtonAction(), _canExecute));
            }
        }

        public SimpleUserControlViewModel()
        {
            _canExecute = true; 
        }

        public void ButtonAction()
        {
            Button1 = !Button1;
        }
    }
}
